diff -Nru dpkg.patched/lib/dpkg/dir.c dpkg.patched.02/lib/dpkg/dir.c
--- dpkg.patched/lib/dpkg/dir.c	2010-02-24 17:05:35.207917256 +0100
+++ dpkg.patched.02/lib/dpkg/dir.c	2010-02-26 21:20:02.870717405 +0100
@@ -120,3 +120,19 @@
 
 	free(dirname);
 }
+
+void
+dir_sync_contents_parent(const char *path)
+{
+	char *dirname, *slash;
+
+	dirname = m_strdup(path);
+
+	slash = strrchr(dirname, '/');
+	if (slash != NULL) {
+		*slash = '\0';
+		dir_sync_contents(dirname);
+	}
+
+	free(dirname);
+}
diff -Nru dpkg.patched/lib/dpkg/dir.h dpkg.patched.02/lib/dpkg/dir.h
--- dpkg.patched/lib/dpkg/dir.h	2010-02-24 17:05:35.207917256 +0100
+++ dpkg.patched.02/lib/dpkg/dir.h	2010-02-26 21:20:10.154742899 +0100
@@ -28,6 +28,7 @@
 DPKG_BEGIN_DECLS
 
 void dir_sync_contents(const char *path);
+void dir_sync_contents_parent(const char *path);
 void dir_sync(DIR *dir, const char *path);
 void dir_sync_path(const char *path);
 void dir_sync_path_parent(const char *path);
diff -Nru dpkg.patched/src/processarc.c dpkg.patched.02/src/processarc.c
--- dpkg.patched/src/processarc.c	2010-02-24 17:05:35.215922475 +0100
+++ dpkg.patched.02/src/processarc.c	2010-02-26 21:24:49.930792586 +0100
@@ -222,7 +222,7 @@
    * files. As neither dpkg-deb nor tar do explicit fsync()s, we have to do
    * them here. XXX: We might replace this at some point with an internal
    * tar implementation. */
-  dir_sync_contents(cidir);
+  dir_sync_contents_parent(cidir);
 
   parsedb(cidir, pdb_recordavailable | pdb_rejectstatus | pdb_ignorefiles,
           &pkg,NULL,NULL);
